<?php
/* vim: set et ts=4 sw=4 sts=4 ai: */
// +----------------------------------------------------------------------+
// | Generate rss feed                                                    |
// +----------------------------------------------------------------------+
// | @version $Revision: 1.12 $
// +----------------------------------------------------------------------+

//----- This page isn't for HTML delivery so all the normal templating and
//      caching won't work. Instead, have to handle caching manually

// Double-check
if(FEATURE_RSS!==true) {
    exit;
}
define("FEATURE_RSS_HEADER","Content-type: application/rss+xml; charset=utf-8");

// Check cache...
if(FEATURE_CACHE===true && $db->phptype=="sqlite") {
    $dbfile = $db->dsn["database"];
    $cache_file = CACHE_DIR . "/rss" . $path_parts[2];
    if(file_exists($cache_file)) {
        $cache_time = filemtime($cache_file);
        $db_time = filemtime($dbfile);
        $age_diff = $cache_time - $db_time;
        $cache_age = date("U") - $cache_time;
        $caller_time = filemtime(__FILE__);
        $stale = FEATURE_CACHE_REFRESH * 60;

        if( $age_diff > 0 and
            $cache_age < $stale and
            $cache_time > $caller_time) {
            header(FEATURE_RSS_HEADER);
            readfile($cache_file);
            #echo "<!-- cache read -->\n";
            exit;
        }
    }
}

$category = $path_parts[2] ? str_replace(".rss","",$path_parts[2]) : false;
if(!$category && !FEATURE_SHOWALL) {
    $page->fail($ERRORS["unknownrequest"]);
}
if (!$rss = getRSS($category)) {
    $page->fail($ERRORS["queryfail"]);
}

$tmpl = new HTML_Template_IT(TEMPLATE_DIR,array("use_preg"=>false));
$tmpl->loadTemplateFile("rss.tmpl");
foreach($rss as $row) {
    $row["url"] = $_SERVER["HTTP_HOST"] . ROOT . "/" . $row["images.id"];
    $tz_offset = sprintf("%03d",date("Z")/3600) . ":00";
    if(date("Z")>0) {
        $tz_offset = "+" . $tz_offset;
    }
    $row["date"] = date("Y-m-d\TH:i:s",$row["images.date"]) . $tz_offset;
    $row["title"] = htmlspecialchars(stripslashes($row["images.title"]));
    $row["title"] = $row["images.title"] ?
        htmlspecialchars(stripslashes($row["images.title"])) : $STRINGS["untitled"];
    $row["name"] = htmlspecialchars(stripslashes($row["images.name"]));
    $row["filename"] = ereg_replace("^[0-9]+-","",$row["images.file"]);
    $row["thumb_url"] = $_SERVER["HTTP_HOST"] .
        getImageUrl($row["images.id"],$row["images.file"],true);
    $row["comment"] = $row["images.comment"] ?
        htmlspecialchars(stripslashes($row["images.comment"])) :
        "";
    $row["resolution"] = $row["images.resolution"];
    $row["size"] = $row["images.size"];
    $row["type"] = $row["images.type"];
    $row["replies"] = $row["replies.replies"] ? $row["replies.replies"] : 0;
    $row["imgreplies"] = $row["replies.imgreplies"] ? $row["replies.imgreplies"] : 0;

    $tmpl->setCurrentBlock("sequence");
    $tmpl->setVariable("seq_url",$row["url"]);
    $tmpl->parseCurrentBlock();

    $tmpl->setCurrentBlock("item");
    $tmpl->setVariable($row);
    $tmpl->parseCurrentBlock();
}

$tmpl->setVariable(array(
    "ABSOLUTE_ROOT" => ABSOLUTE_ROOT,
    "TITLE"         => HTML_TITLE,
));

if(FEATURE_CACHE===true) {
    if($fp = @fopen($cache_file,"w")) {
        @fwrite($fp,$tmpl->get());
    }
}
    
header(FEATURE_RSS_HEADER);
$tmpl->show();
#echo "<!-- generated -->\n";

exit;   // Don't let regular wrapper take back control
?>
